#define INCL_WIN
#define INCL_PM
  #define INCL_DOSPROCESS
#define INCL_BASE
#include <os2emx.h>
#include <OS2.H>
#include <string.h>
#include <io.h>
#include <STDLIB.H>
#include <STDIO.H>

ULONG getbutton( char *txt) {
  char template[71]="OK CANCEL OKCANCEL ENTER ENTERCANCEL RETRYCANCEL ABORTRETRYIGNORE YESNO";
  _nls_strupr(txt);
  switch(strstr(template, txt) - template) {
    case 0:
      return MB_OK;
      break;
    case 3:
      return MB_CANCEL;
      break;
    case 10:
      return MB_OKCANCEL;
      break;
    case 19:
      return MB_ENTER;
      break;
    case 25:
      return MB_ENTERCANCEL;
      break;
    case 37:
      return MB_RETRYCANCEL;
      break;
    case 49:
      return MB_ABORTRETRYIGNORE;
      break;
    case 66:
      return MB_YESNO;
      break;
  }
  fprintf( stderr, "%s%s\n", txt, "; invalid button type");
  exit(-1);
}

void os2title(char *title){
  static SWCNTRL sw;
  static HSWITCH hswitch;
  static PSWCNTRL psw = (PSWCNTRL) &sw;
  /* save current process title */
  hswitch = WinQuerySwitchHandle(0, getpid());
  WinQuerySwitchEntry(hswitch, psw);
  if(psw->uchVisibility) {
    strcpy(title, psw->szSwtitle);
  }
}

int main(int argc, char *argv[]) {
  int ret;
  char title[120];
     HAB hab;
     HMQ hmq;
  PPIB ppib;
  PTIB ptib;
  ULONG button;

  if (argc < 3) {
    fprintf( stderr, "Missing parameters\n");
    return -1;
  }
  if (argc == 3) button = MB_OK;
  else button = getbutton( argv[3]);
  if (strcmp( argv[1], "-") == 0) os2title( title);
  else strcpy( title, argv[1]);

  DosGetInfoBlocks(&ptib,&ppib);
  if (ppib->pib_ultype == 2)          /* VIO */
     ppib->pib_ultype = 3;

  hab = WinInitialize(0);
  hmq = WinCreateMsgQueue(hab, 0);
  if (!hmq) {
    fprintf( stderr,"Cannot create a message queue\n");
    return -1;
  }
  ret = WinMessageBox(HWND_DESKTOP, 0,
     argv[2], title, 100, button|MB_MOVEABLE|MB_SYSTEMMODAL);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  return ret;
}
